#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTreeWidget>
#include <QPushButton>
#include <QSpinBox>

namespace Ui {
class MainWindow;
}

class Factory : public QTreeWidgetItem
{
public:
    QWidget * create ();
};

class ButtonFactory : public Factory
{
public:
    QWidget * create () { return new QPushButton; }
    ButtonFactory () { setText (0, "Button"); }
};

class EditFactory : public Factory
{
public:
    QWidget * create () { return new QSpinBox; }
    EditFactory () { setText (0, "Spin Box"); }
};


class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
};



#endif // MAINWINDOW_H
